# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html),
and is generated by [Changie](https://github.com/miniscruff/changie).



## sdk/elixir/v0.9.7 - 2024-01-19

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.7`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.7).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Dependencies
- Bump Engine to v0.9.7 by @github-actions in https://github.com/dagger/dagger/pull/6460

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.9.6 - 2024-01-12

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.6`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.6).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Dependencies
- Bump Engine to v0.9.6 by @github-actions in https://github.com/dagger/dagger/pull/6410

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.9.5 - 2023-12-21

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.5`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.5).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Dependencies
- Bump Engine to v0.9.5 by @github-actions in https://github.com/dagger/dagger/pull/6309

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.9.4 - 2023-12-08

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.4`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.4).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Fixed
- Fix `Container.with_service_binding` not convert `Service` into id by @wingyplus in https://github.com/dagger/dagger/pull/6099

### Dependencies
- Bump Engine to v0.9.4 by @github-actions in https://github.com/dagger/dagger/pull/6239

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.9.3 - 2023-11-03

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.3`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.3).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Dependencies
- Bump Engine to v0.9.3 by @github-actions in https://github.com/dagger/dagger/pull/6061

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.9.2 - 2023-10-30

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.2`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.2).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html

### Dependencies

- Bump Engine to v0.9.2 by @github-actions in https://github.com/dagger/dagger/pull/6024

### What to do next

- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.9.1 - 2023-10-26

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.1`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.1).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Dependencies
- Bump Engine to v0.9.1 by @github-actions in https://github.com/dagger/dagger/pull/5969

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.9.0 - 2023-10-20

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.0`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.0).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html

### 🔥 Breaking Changes

- engine: new services API with container <=> host networking, explicit start/stop by @vito in https://github.com/dagger/dagger/pull/5557
- implement new conventions for IDable objects by @vito in https://github.com/dagger/dagger/pull/5881

### Fixed

- fix Dagger.Container.with_env_variable/4 crash by @Thanabodee Charoenpiriyakij in https://github.com/dagger/dagger/pull/5837

### Dependencies

- Bump Engine to v0.9.0 by @github-actions in https://github.com/dagger/dagger/pull/5940

### What to do next

- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.8.8 - 2023-10-11

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.8`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.8).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Dependencies
- Bump Engine to v0.8.8 by @github-actions in https://github.com/dagger/dagger/pull/5877

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.8.7 - 2023-09-18

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.7`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.7).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Dependencies
- Bump Engine to v0.8.7 by @github-actions in https://github.com/dagger/dagger/pull/5799

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.8.6 - 2023-09-18

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.6`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.6).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Dependencies
- Bump Engine to v0.8.6 by @github-actions in https://github.com/dagger/dagger/pull/5795

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.8.5 - 2023-09-13

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.5`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.5).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Added
- Throw error when workdir config on session by @wingyplus in https://github.com/dagger/dagger/pull/5689

### Fixed
- Dagger.connect!/1 always returns `:error` when using stable engine by @wingyplus in https://github.com/dagger/dagger/pull/5665
- Calling `id/1` before constructing GraphQL argument by @wingyplus in https://github.com/dagger/dagger/pull/5674

### Dependencies
- Bump Engine to v0.8.5 by @github-actions in https://github.com/dagger/dagger/pull/5779

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.8.4 - 2023-08-17

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.4`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.4).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Added
- Support version compatibility check by @wingyplus in https://github.com/dagger/dagger/pull/5577

### Fixed
- fix connect always timeout by @wingyplus in https://github.com/dagger/dagger/pull/5646
- Fallback to stable cli when cannot find local cli binary by @wingyplus in https://github.com/dagger/dagger/pull/5654

### Dependencies
- Bump Engine to v0.8.4 by @github-actions in https://github.com/dagger/dagger/pull/5657

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.8.3 - 2023-08-16

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.3`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.3).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Dependencies
- Bump Engine to v0.8.3 by @github-actions in https://github.com/dagger/dagger/pull/5643

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/elixir/v0.8.2 - 2023-08-10

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.2`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.2).

🧪 https://hex.pm/packages/dagger
📖 https://hexdocs.pm/dagger/Dagger.html


### Dependencies
- Bump Engine to v0.8.2 by @github-actions in https://github.com/dagger/dagger/pull/5613

### What to do next
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)
